#pragma once
#include <utils.h>
#include "Entity3d.h"
#include "../../disjoint/DisjointSets.h"
#include "Vector3d.h"
#include "WindowMapping.h"

#define TEXTURE_COUNT 5

class Entity3dCollection
{
public:
	void AddEntity(Entity3d ent, int x, int y, WindowMapping &mapping);
	void Clear();
	void Render(GLuint *textures, GLuint firstEntityList, int texturecount);
	void CompileDisplayLists(GLuint firstEntityList, int texturecount);

	bool ConstrainToIndoors(Vector3d &originalPoint, const Vector3d &delta, int gridx, int gridy, int gridx2, int gridy2);

	void GetNodeExits(int x, int y, ConnectionStruct &exits);

	void EnsureAdjacentConnectivity();

	DisjointSets m_disjointSets;

	Entity3dCollection(void);
	~Entity3dCollection(void);
private:
	Entity3d m_entities[MAX_ENTITIES][MAX_ENTITIES];
	void DiscoverConnectedNodes(int x, int y, ConnectionStruct &connections, bool excludeBoxes = false);
	void UnionTwoNodes(int x, int y, int deltax, int deltay);
	bool AreDisjoint(int x, int y, int deltax, int deltay);
	void RenderSingleNode(int x, int y, int texture);
};