#include "Timer.h"
//WINDOWS VERSION.

#include "windows.h"

Timer::Timer(void)
{
	//get time now, place in class members
	LARGE_INTEGER timenow, tickssecond;
	QueryPerformanceFrequency(&tickssecond);
	QueryPerformanceCounter(&timenow);
	
	last_time_measured = timenow.QuadPart;
	ticks_per_ms = tickssecond.QuadPart / 1000;
}

__int64 Timer::TimeElapsed()
{
	//get difference in counter
	LARGE_INTEGER timenow;
	QueryPerformanceCounter(&timenow);
	__int64 diff = timenow.QuadPart - last_time_measured;

	//set new time
	last_time_measured = timenow.QuadPart;

	//translate to ms
	return diff / ticks_per_ms;
}

Timer::~Timer(void)
{
}
