#pragma once
#include <utils.h>
#include "Serializable.h"

class Vector3d: public Serializable
{
public:

	float x,y,z;

	virtual void SaveToXml(TiXmlElement *currentElement);
	virtual void LoadFromXml(TiXmlElement *currentElement);

	Vector3d(void);
	Vector3d(float newX, float newY, float newZ);
	Vector3d(Vector3d const& source);

	Vector3d operator -(Vector3d const& source);
	Vector3d operator +(Vector3d const& source);
	Vector3d operator *(float amount);

	float Dot(Vector3d param);
	float Magnitude();
	Vector3d Normalize();

	void Initialize(float newX, float newY, float newZ);

	~Vector3d(void);
};